<?php
/**
 * Created by PhpStorm.
 * User: hquispe
 * Date: 7/28/2016
 * Time: 11:53 AM
 */

namespace app\controllers;


use app\commands\Clasificadores\TipoClasificador;
use app\commands\MapasCapas;
use app\commands\Proyectos;
use app\models\Capa;
use app\models\Capadetalle;
use app\models\Clasificadorcomun;
use app\models\ClasificadorcomunSearch;
use app\models\ExcelProyectoUpload;
use app\models\ExcelUpload;
use app\models\KmzUpload;
use app\models\Proyecto;
use app\models\Proyectodetalle;
use moonland\phpexcel\Excel;
use Yii;
use yii\base\Exception;
use yii\bootstrap\Html;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use yii\helpers\FileHelper;
use yii\helpers\Inflector;
use yii\helpers\Url;
use yii\web\Controller;
use yii\web\Response;
use yii\web\UploadedFile;

class ImportacionController extends Controller
{
    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'access'=>[
                'class'=>AccessControl::classname(),
                'rules'=>[
                    [
                        'allow'=>true,
                        'roles'=>['@']
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * Displays index page.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }


    //controlador base para importar un archivo kmz
    public function actionKmz(){
        date_default_timezone_set('America/La_Paz');

        $model = new KmzUpload();
        //Yii::getAlias('@webroot')."/kml/Departamento.kml";
        $files = FileHelper::findFiles(Yii::getAlias('@webroot')."/kmz/");

        $comboTipoMapa = ClasificadorcomunSearch::combo(TipoClasificador::TipoMapa);

        return $this->render('_impkmz', [
            'model' => $model,
            'archivos'=>$files,
            'comboTipoMapa'=>$comboTipoMapa,
        ]);

    }

    //controlador que guarda un archivo kmz
    public function actionSavekmz(){
        $model = new KmzUpload();
        if(Yii::$app->request->isPost) {
            $model->load( Yii::$app->request->post() );
            $model->KmzFile = UploadedFile::getInstance($model, 'KmzFile');

            if( $model->validation() ) {



                $TipoMapas = ClasificadorcomunSearch::combo(TipoClasificador::TipoMapa);
                $file = $model->dir.'/' . Inflector::camelize($TipoMapas[$model->TipoMapa]) . '.' . $model->KmzFile->extension;
                $model->KmzFile->saveAs(Yii::getAlias('@webroot').$file);

                /** @var  Clasificadorcomun $clasific */
                $clasific = Clasificadorcomun::find()->where(["IdClasificadorComun"=>$model->TipoMapa])->one();
                $clasific->ValorExtra = $file;
                $clasific->save();

                Yii::$app->session->setFlash('success', "El Archivo Se Guardo Satisfactoriamente!");

            }else{
                Yii::$app->session->setFlash('danger', "No se pudo Guardar el archivo");
            }


        }
        return $this->redirect(['kmz']);
    }

    //ajax obtener el archivo kmz
    public function actionGetkmz($id){

        //set content type
        Yii::$app->response->format = Response::FORMAT_RAW;
        $headers = Yii::$app->response->headers;
        $headers->add('Content-Type', 'application/octet-stream');

        /** @var  Clasificadorcomun $model */
        $model = Clasificadorcomun::find()->where(["IdClasificadorComun"=>$id])->one();
        if( is_null($model) ) return "";

        //$file = Yii::getAlias('@webroot')."/kml/Departamento.kml";
        $file = Yii::getAlias('@webroot').$model->ValorExtra;

        if( file_exists( $file ) ){
           // echo file_get_contents($file);
            Yii::$app->response->sendFile($file);
        }
    }


    //controlador que base para importar archvivo excel. ventana para el formulario
    public function actionCapaexcel(){
        date_default_timezone_set('America/La_Paz');
        $model = new ExcelUpload();

        $comboCapaEstadistico = Clasificadorcomun::find()->where(["IdTipoClasificadorComun"=>4 ])->all();
        $comboCapaEstadistico = ArrayHelper::map($comboCapaEstadistico, 'IdClasificadorComun','Nombre' );

        $comboTipoMapa = Clasificadorcomun::find()->where(["IdTipoClasificadorComun"=>5 ])->all();
        $comboTipoMapa = ArrayHelper::map($comboTipoMapa, 'IdClasificadorComun','Nombre' );

        return $this->render('_formExcelUpload', [
            'model' => $model,
            'comboCapaEstadistico'=>$comboCapaEstadistico,
            'comboTipoMapa'=>$comboTipoMapa

        ]);
    }
    // action que guarda excel de  capas estaticas
    public function actionSavexml(){

        $model = new ExcelUpload();

        if(Yii::$app->request->isPost){
            $model->load(Yii::$app->request->post());

            $model->archivo = UploadedFile::getInstance($model, 'archivo');
            if( !$model->validate() ) return false;



            $datos = Excel::widget([
                'mode' => 'import',
                'fileName' =>$model->archivo->tempName,
                'setFirstRecordAsKeys' => false,
                'setIndexSheetByName' => false
                //'getOnlySheet' => 'Hoja1'
            ]);

            $pos_head = 2; //<-- fila excel donde comienza la cabecera
            $keyYears = $datos[$pos_head];

            $transaction = Yii::$app->db->beginTransaction();
            try{
                /** @var Capa $capa */
                $capa = Capa::find()->where(['IdcTipoCapa'=> $model->TipoCapa,'IdcTipoMapa'=>$model->TipoMapa ])->one();
                if( is_null($capa) ){
                    $capa = new Capa();
                    $capa->IdcTipoCapa = $model->TipoCapa;
                    $capa->IdcTipoMapa = $model->TipoMapa;
                    $capa->IdCreadoPor = Yii::$app->user->id;
                    $capa->FechaCreacion = date("Y-m-d H:i:s");
                    $capa->IdModificadoPor = $capa->IdCreadoPor;
                    $capa->FechaModificacion = $capa->FechaCreacion;
                    if(!$capa->save()) throw new Exception("error al grabar Capa");
                }else{
                    $capa->IdModificadoPor = Yii::$app->user->id;
                    $capa->FechaModificacion = date("Y-m-d H:i:s");
                    $capa->save();

                    //elminando los detalles de capa
                    Capadetalle::deleteAll('IdCapa = :idcapa ', [':idcapa' => $capa->IdCapa]);

                }

                for($i = $pos_head + 1; $i<=count( $datos ); $i++){
                    if( $datos[$i]["A"]== null ) break;
                    //echo "<hr>";
                    foreach( $datos[$i] as $key => $valor  ){

                        if( $valor==null )  break;
                        else{
                            if( $key != "A" ){

                                $capaDet = new Capadetalle();
                                $capaDet->IdCapa = $capa->IdCapa;
                                $capaDet->Codigo = $datos[$i]["A"];
                                $capaDet->Anio = $keyYears[$key];
                                $capaDet->valor = str_replace(',',"",str_replace("%",'',$valor));

                                if( !$capaDet->save() )  throw new Exception("Error al guardar capadetalle");

                                //echo "cod:".$datos[$i]["A"]." año:".$keyYears[$key]." valor : ".$capaDet->valor. " <br>";

                            }
                        }

                    }
                }

                $transaction->commit();
                Yii::$app->session->setFlash('success', "El Archivo Se Guardo Satisfactoriamente!");



            }catch (\Exception $e) {
                $transaction->rollBack();
                Yii::$app->session->setFlash('danger', "No se pudo Guardar el archivo [".$e->getMessage()." ".$e->getLine()."]");

                //echo $e->getMessage()." ".$e->getLine();

            }

            return $this->redirect(['capaexcel']);







        }



    }


    public function actionProyectoexcel(){
        date_default_timezone_set('America/La_Paz');
        $model = new ExcelProyectoUpload();


        return $this->render('_formProyectoExcel', [
                'model' => $model,
        ]);
    }

    public function actionProyectoexcelsave(){

        date_default_timezone_set('America/La_Paz');

        $model = new ExcelProyectoUpload();


        if(Yii::$app->request->isPost){
            $model->load(Yii::$app->request->post());

            $model->archivo = UploadedFile::getInstance($model, 'archivo');
            if( !$model->validate() ) return false;



            $datos = Excel::widget([
                    'mode' => 'import',
                    'fileName' =>$model->archivo->tempName,
                    'setFirstRecordAsKeys' => false,
                    'setIndexSheetByName' => false
                //'getOnlySheet' => 'Hoja1'
            ]);


            $row_init = 2; //<-- fila excel donde comienza la cabecera
            $col_init = "B"; // columna

            $col_inversion=null;
            $col_latitud=null;
            $col_longitud=null;
            $col_descripcion=null;
            $col_linkExcel = null;

            $transaction = Yii::$app->db->beginTransaction();
            try{

                if( isset( $datos[0] ) ){
                    // obtiene la primera pagina
                    $datosExcel = $datos[0];
                }else{
                    $datosExcel = $datos;
                }


                    //obteniendo Keys de las cabeceras  de la lista
                    $ok=false;
                    $keyHead = [];
                    foreach($datosExcel[ $row_init ] as $key=>$col ){
                        if( $key == $col_init ) $ok=true;
                        if($ok){
                            if( empty($col) )  break;
                            $keyHead[$key]= iconv("UTF-8", "ISO-8859-1", $col );

                            //extraendo las columnas estaticas que deberia tener el excel
                            if( strtoupper($col) == strtoupper(Proyectos::Inversion) )   $col_inversion = $key;
                            if( strtoupper($col) == strtoupper(Proyectos::Latitud) )     $col_latitud = $key;
                            if( strtoupper($col) == strtoupper(Proyectos::Longitud) )    $col_longitud = $key;
                            if( strtoupper($col) == strtoupper(Proyectos::Descripcion) ) $col_descripcion = $key;
                            if( strtoupper($col) == strtoupper(Proyectos::LinkExcel) ) $col_linkExcel = $key;

                        }
                    }


                   //Es obligaorio el campo inversión
                   if( empty($col_inversion) ) throw new Exception(" El Campo 'Inversión' no se Encuentra. ");





                    //obteniendo datos para almacenar a BD
                    for( $i = $row_init+1;  $i<=count($datosExcel); $i++   ){


                        //extraendo datos y verificando si todas las columnas tengan informacion
                        $data=[];
                        $ok = false;
                        foreach( $keyHead as $key=>$campo ){
                            //echo $campo.": ".$datosExcel[$i][$key]." ";
                            $data[$key] = iconv("UTF-8", "ISO-8859-1", $datosExcel[$i][$key] );
                            if( !empty($datosExcel[$i][$key]) ) $ok = true;
                        }

                        if( $ok==true ){
                            // BD Proyecto
                            /** @var Proyecto $proyecto */
                            $proyecto = Proyecto::find()->where(["NombreProyecto"=>$datosExcel[$i][ $col_inversion ]  ])->one();

                            if( is_null($proyecto) ){
                                $proyecto = new Proyecto();
                                $proyecto->NombreProyecto = $datosExcel[$i][ $col_inversion ];
                                $proyecto->FechaCreacion = date("Y-m-d H:i:s");
                                $proyecto->IdCreadoPor = Yii::$app->user->id;
                                $proyecto->Latitud = isset($datosExcel[$i][ $col_latitud ])?$datosExcel[$i][ $col_latitud ]:null;
                                $proyecto->Longitud = isset($datosExcel[$i][ $col_longitud ])?$datosExcel[$i][ $col_longitud ]:null;

                            }else{

                                //$proyecto->Latitud = isset($datosExcel[$i][ $col_latitud ])?$datosExcel[$i][ $col_latitud ]:$proyecto->Latitud;
                                //$proyecto->Longitud = isset($datosExcel[$i][ $col_longitud ])?$datosExcel[$i][ $col_longitud ]:$proyecto->Longitud;

                            }

                            //actualizando campos de proyecto

                            $proyecto->Descripcion = isset($datosExcel[$i][ $col_descripcion ])?$datosExcel[$i][ $col_descripcion ]:null;
                            $proyecto->LinkExcel = isset($datosExcel[$i][ $col_linkExcel ])?$datosExcel[$i][ $col_linkExcel ]:null;
                            $proyecto->FechaModificacion = date("Y-m-d H:i:s");
                            $proyecto->IdModificadoPor = Yii::$app->user->id;

                            if( !$proyecto->save() ) throw new Exception("Error al guardar Proyecto");


                            //BD ProyectoDetalle
                            Proyectodetalle::deleteAll('IdProyecto = :idproyecto ', [':idproyecto' => $proyecto->IdProyecto  ]);
                            foreach($data as $key=>$valor){


                                if( $key!=$col_inversion && $key!= $col_latitud && $key!=$col_longitud && $key!=$col_descripcion && $key!=$col_linkExcel ){

                                    $proyDetalle = new Proyectodetalle();
                                    $proyDetalle->IdProyecto = $proyecto->IdProyecto;
                                    $proyDetalle->Campo = utf8_encode( $keyHead[$key] ) ;
                                    $proyDetalle->Valor = utf8_encode($valor);
                                    if( !$proyDetalle->save() ) throw new Exception("Error al guardar ProyectoDetalle");

                                }


                            }
                            //echo "<br>";
                        }else{
                            // fin de lectura todas las columnas de la fila estan vacias :|
                            break;
                        }
                    }


                    $transaction->commit();
                    Yii::$app->session->setFlash('success', "La importación del archivo fue satisfactoria. ");





            }catch (\Exception $e) {
                $transaction->rollBack();
                Yii::$app->session->setFlash('danger', "No se pudo Guardar el archivo [".$e->getMessage()." ".$e->getLine()."]");

                echo $e->getMessage()." ".$e->getLine();

            }

            return $this->redirect(['proyectoexcel']);

        }// end if


    }









}