<?php
/**
 * Application level Controller
 *
 * This file is application-wide controller file. You can put all
 * application-wide controller-related methods here.
 *
 * CakePHP(tm) : Rapid Development Framework (http://cakephp.org)
 * Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright     Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 * @link          http://cakephp.org CakePHP(tm) Project
 * @package       app.Controller
 * @since         CakePHP(tm) v 0.2.9
 * @license       http://www.opensource.org/licenses/mit-license.php MIT License
 */

App::uses('Controller', 'Controller');

/**
 * Application Controller
 *
 * Add your application-wide methods in the class below, your controllers
 * will inherit them.
 *
 * @package		app.Controller
 * @link		http://book.cakephp.org/2.0/en/controllers.html#the-app-controller
 */
class AppController extends Controller {
	var $components = array('Auth', 'Session', 'Cookie', 'Email', 'RequestHandler');	
	var $helpers = array('Html', 'Form','Session','Funciones');
	var $uses=array('Mensaje','Anuncio','InfoContacto','Tipo','Categoria','Ciudad','Zona');	
	var $agenciaID;
	var $asesorID;
	
		// Sólo permitir sólo los controladores de inicio de sesión
	public function beforeFilter() {
	  $this->Auth->loginRedirect = array('controller' => 'users', 'action' => 'menu');
  		$this->Auth->logoutRedirect  = array('controller' => 'users', 'action' => 'login');
  		$this->Auth->allow('signup', 'confirm');//Permite a ciertas acciones no haber loguerse
  		$this->Auth->authorize = array('Controller');

  		
		$this->set('loggedIn', $this->Auth->user('id'));
        $this->set('rol', $this->Auth->user('rol'));
        $this->set('username', $this->Auth->user('username'));
  		
  		
  		
	}
	 
	public function isAuthorized($user) {
	    // aquí es donde debemos verificar el rol y dar acceso basado en roles
	     
	    return true;
	}
	
	function combos()
	{   //DA informacion en los diferentes combos de ciudad modelo tipo marcas
	    $tiposComB=$this->Tipo->find('list',array('fields'=>'Tipo.id,Tipo.nombre'));
		$categoriaComB=$this->Categoria->find('list',array('fields'=>'Categoria.id,Categoria.nombre'));
		$zonaComB=$this->Zona->find('list',array('fields'=>'Zona.id,Zona.nombre'));		
		$ciudadComB=$this->Ciudad->find('list',array('fields'=>'Ciudad.id,Ciudad.nombre'));		
		$this->set('tipcomb',$tiposComB);
		$this->set('catcomb',$categoriaComB);
		$this->set('zoncomb',$zonaComB);
		$this->set('ciucomb',$ciudadComB);		
	}
		
	function galeria()
	{	 //para la galeria de fotos	
		 $this->paginate = array('limit' => 20,'conditions'=>array('Anuncio.destacado'=>1,'Anuncio.estado'=>1));
		 $this->Anuncio->recursive = 0;
		 $this->set('anuncio', $this->Paginator->paginate()); 
		 		
	}
	
	function ComboTipoFoto()
	{ $tipoFoto=$this->TipoFoto->find('list',array('fields'=>'TipoFoto.id,TipoFoto.nombre'));
 	  $this->set('tipfcomb',$tipoFoto);	
	}
	
	function ComboAnuncioCodigo()
	{ $tipoAnuncio=$this->Anuncio->find('list',array('fields'=>'Anuncio.id,Anuncio.codigo'));
 	  $this->set('tipacomb',$tipoAnuncio);	
	}
}
