<?php
App::uses('AppController', 'Controller');
/**
 * Contactos Controller
 *
 * @property Contacto $Contacto
 * @property PaginatorComponent $Paginator
 */
class ContactosController extends AppController {

/**
 * Components
 *
 * @var array
 */
	public $components = array('Paginator');
	public $uses=array('Contacto','Anuncio','InfoContacto','Tipo','Categoria','Ciudad','Zona');

/**
 * index method
 *
 * @return void
 */
	public function index() {
		$this->Contacto->recursive = 0;
		$this->set('contactos', $this->Paginator->paginate());
	}

/**
 * view method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function view($id = null) {
		if (!$this->Contacto->exists($id)) {
			throw new NotFoundException(__('Invalid contacto'));
		}
		$options = array('conditions' => array('Contacto.' . $this->Contacto->primaryKey => $id));
		$this->set('contacto', $this->Contacto->find('first', $options));
	}

/**
 * guarda los datos del formulario contactos
 *
 * @return void
 */
	public function add() {
		parent::combos();
		if ($this->request->is('post')) {
				
									
				$this->Contacto->create();
			if ($this->Contacto->save($this->request->data)) {
				/*Email para ITAI*/
					$ti=$this->request->data['Contacto']['titulo'];
					$no=$this->request->data['Contacto']['nombre'];
					$em=$this->request->data['Contacto']['email'];
					$te=$this->request->data['Contacto']['telefonos'];
					$ce=$this->request->data['Contacto']['celular'];
					$me=$this->request->data['Contacto']['mensaje'];
																
					$mensaje="
					CONTACTOS ITAI \n
					Titulo: $ti \n
					Nombre: $no \n
					Email:  $em \n
					Telefonos: $te \n
					Celular: $ce \n
					Mensaje: $me \n	";
															
					$from=$em;					
					$for=$this->Contacto->generarCorreoEmpresa($this,6); //Obtenemos el correo dela empresa																				
					$tema="CONTACTOS ITAI";			
					mail($for,$tema,$mensaje,$from);
					/*EMAIL PARA ITAI*/
				
				$this->Session->setFlash(__('Los datos del Contacto fue grabado.'));
				return $this->redirect(array('action' => 'fin'));
			} else {
				$this->Session->setFlash(__('Los datos de Contacto no pudieron ser grabado. Por favor, intente otra vez.'));
			}
		}
	}

/**
 * edit method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function edit($id = null) {
		if (!$this->Contacto->exists($id)) {
			throw new NotFoundException(__('Invalid contacto'));
		}
		if ($this->request->is(array('post', 'put'))) {
			if ($this->Contacto->save($this->request->data)) {
				$this->Session->setFlash(__('The contacto has been saved.'));
				return $this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The contacto could not be saved. Please, try again.'));
			}
		} else {
			$options = array('conditions' => array('Contacto.' . $this->Contacto->primaryKey => $id));
			$this->request->data = $this->Contacto->find('first', $options);
		}
	}

/**
 * delete method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function delete($id = null) {
		$this->Contacto->id = $id;
		if (!$this->Contacto->exists()) {
			throw new NotFoundException(__('Invalid contacto'));
		}
		$this->request->allowMethod('post', 'delete');
		if ($this->Contacto->delete()) {
			$this->Session->setFlash(__('The contacto has been deleted.'));
		} else {
			$this->Session->setFlash(__('The contacto could not be deleted. Please, try again.'));
		}
		return $this->redirect(array('action' => 'index'));
	}

/**
 * admin_index method
 *
 * @return void
 */
	public function admin_index() {
		
		$this->layout='bootcontactos';	
		$this->paginate = array('limit' => 15, 'order' => array('Contacto.id' => 'desc')); //ordenar anuncio por un campo
		$this->Contacto->recursive = 0;
		$this->set('contactos', $this->Paginator->paginate());
	}

/**
 * admin_view method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_view($id = null) {
		if (!$this->Contacto->exists($id)) {
			throw new NotFoundException(__('Invalid contacto'));
		}
		$options = array('conditions' => array('Contacto.' . $this->Contacto->primaryKey => $id));
		$this->set('contacto', $this->Contacto->find('first', $options));
	}

/**
 * admin_add method
 *
 * @return void
 */
	public function admin_add() {
		if ($this->request->is('post')) {
			$this->Contacto->create();
			if ($this->Contacto->save($this->request->data)) {
				$this->Session->setFlash(__('The contacto has been saved.'));
				return $this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The contacto could not be saved. Please, try again.'));
			}
		}
	}

/**
 * admin_edit method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_edit($id = null) {
		if (!$this->Contacto->exists($id)) {
			throw new NotFoundException(__('Invalid contacto'));
		}
		if ($this->request->is(array('post', 'put'))) {
			if ($this->Contacto->save($this->request->data)) {
				$this->Session->setFlash(__('The contacto has been saved.'));
				return $this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The contacto could not be saved. Please, try again.'));
			}
		} else {
			$options = array('conditions' => array('Contacto.' . $this->Contacto->primaryKey => $id));
			$this->request->data = $this->Contacto->find('first', $options);
		}
	}

/**
 * admin_delete method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_delete($id = null) {
		$this->Contacto->id = $id;
		if (!$this->Contacto->exists()) {
			throw new NotFoundException(__('Invalid contacto'));
		}
		$this->request->allowMethod('post', 'delete');
		if ($this->Contacto->delete()) {
			$this->Session->setFlash(__('The contacto has been deleted.'));
		} else {
			$this->Session->setFlash(__('The contacto could not be deleted. Please, try again.'));
		}
		return $this->redirect(array('action' => 'index'));
	}
	
	function beforeFilter(){
        $this->Auth->allow('add','fin','captcha_image'); 
		parent::beforeFilter();
    }
	
	function fin()
	{	
		parent::combos();
	}
	
	function daEmpresa($id=null)
	{
		
	} 
}
