<?php
App::uses('AppController', 'Controller');
App::import('Model', 'User');
/**
 * Fotos Controller
 *
 * @property Foto $Foto
 * @property PaginatorComponent $Paginator
 */
class FotosController extends AppController {

/**
 * Components
 *
 * @var array
 */
	public $components = array('Paginator');
	public $uses=array('Foto','TipoFoto','Anuncio');
	
/**
 * index method
 *
 * @return void
 */
	public function index() {
		$this->Foto->recursive = 0;
		$this->set('fotos', $this->Paginator->paginate());
	}

/**
 * view method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function view($id = null) {
		if (!$this->Foto->exists($id)) {
			throw new NotFoundException(__('Invalid foto'));
		}
		$options = array('conditions' => array('Foto.' . $this->Foto->primaryKey => $id));
		$this->set('foto', $this->Foto->find('first', $options));
	}

/**
 * add method
 *
 * @return void
 */
	public function add() {
		if ($this->request->is('post')) {
			$this->Foto->create();
			if ($this->Foto->save($this->request->data)) {
				$this->Session->setFlash(__('The foto has been saved.'));
				return $this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The foto could not be saved. Please, try again.'));
			}
		}
		$anuncios = $this->Foto->Anuncio->find('list');
		$this->set(compact('anuncios'));
	}

/**
 * edit method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function edit($id = null) {
		if (!$this->Foto->exists($id)) {
			throw new NotFoundException(__('Invalid foto'));
		}
		if ($this->request->is(array('post', 'put'))) {
			if ($this->Foto->save($this->request->data)) {
				$this->Session->setFlash(__('The foto has been saved.'));
				return $this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The foto could not be saved. Please, try again.'));
			}
		} else {
			$options = array('conditions' => array('Foto.' . $this->Foto->primaryKey => $id));
			$this->request->data = $this->Foto->find('first', $options);
		}
		$anuncios = $this->Foto->Anuncio->find('list');
		$this->set(compact('anuncios'));
	}

/**
 * delete method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function delete($id = null) {
		$this->Foto->id = $id;
		if (!$this->Foto->exists()) {
			throw new NotFoundException(__('Invalid foto'));
		}
		$this->request->allowMethod('post', 'delete');
		if ($this->Foto->delete()) {
			$this->Session->setFlash(__('The foto has been deleted.'));
		} else {
			$this->Session->setFlash(__('The foto could not be deleted. Please, try again.'));
		}
		return $this->redirect(array('action' => 'index'));
	}

/**
 * admin_index method
 *
 * @return void
 */
	public function admin_index() {
		
		$this->paginate = array('limit' => 30, 'order' => array('Foto.id' => 'desc')); //ordenar anuncio por un campo
		$this->Foto->recursive = 0;
		$this->set('fotos', $this->Paginator->paginate());
		//$this->layout='admin';
		$this->layout='bootFotos';
	}

/**
 * admin_view method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_view($id = null) {
		if (!$this->Foto->exists($id)) {
			throw new NotFoundException(__('Invalid foto'));
		}
		$options = array('conditions' => array('Foto.' . $this->Foto->primaryKey => $id));
		$this->set('foto', $this->Foto->find('first', $options));
		$this->layout='bootFotos';
	}

/**
 * admin_add method
 *
 * @return void
 */
	public function admin_add($id) {
		if (!empty($this->data)) {
			$nn=$this->data['Foto']['nombre'];
				$this->request->data['Foto']['nombre']=$this->SubeArchivo($this->data['Foto']['nombre']);
				$this->request->data['Foto']['nombre_imagen']=$nn['name'];
				$this->request->data['Foto']['tipo_imagen']=$nn['type'];
				$this->request->data['Foto']['tamano_imagen']=$nn['size'];
			$this->Foto->create();
			if ($this->Foto->save($this->data)) {
				$this->Session->setFlash(__('The Foto has been saved', true));
				$this->redirect(array('controller'=>'anuncios','action'=>'fotos'));
			} else {
				$this->Session->setFlash(__('The Foto could not be saved. Please, try again.', true));
			}
		}
		$anuncios = $this->Foto->Anuncio->find('list');
		$this->set(compact('anuncios'));
		$this->set('codann',$id);
		$this->layout='bootFotos';
		parent::ComboTipoFoto();	
		parent::ComboAnuncioCodigo();
	}
	
	public function admin_interior($id)
	{$this->layout='bootFotos';
		  $fe=date("Y-m-j H:i:s");
		if (isset($_FILES["archivos"])) {
         //de se asi, para procesar los archivos subidos al servidor solo debemos recorrerlo

         $tot = count($_FILES["archivos"]["name"]);
         //este for recorre el arreglo mandado
         for ($i = 0; $i < $tot; $i++){
         //con el indice $i, podemos obtener la propiedad que desemos de cada archivo
         //para trabajar con este
            $tmp_name = $_FILES["archivos"]["tmp_name"][$i];  
            $nombre_imagen = $_FILES["archivos"]["name"][$i];                       
			$tipoimagen=$_FILES["archivos"]["type"][$i];    
			$tam=$_FILES["archivos"]["size"][$i];           
			$anuncio_id=$this->data['Foto']['anuncio_id'];  
			$nombre=$this->SubeArchivo2($nombre_imagen,$tmp_name); 
			
			$clientes=new User();
	 	 	$clientes->query("INSERT INTO fotos VALUES('','Foto Interior','$nombre','d','$nombre_imagen','$tipoimagen','$tam','$anuncio_id','2','$fe','$fe') ");
															        				
			}	
			$this->Session->setFlash(__('La foto Interior ha sido Grabada', true));
			
			if(@$this->data['Foto']['terminar']!=1){ //preguntamos si el usuario a terminado de llenar formulario 
				   $this->redirect(array('controller'=>'anuncios','action'=>'index')); 
			    }else
				{   $this->Foto->CompletarFoto(3,$anuncio_id);
					$this->redirect(array('controller' => 'anuncios', 'action' => 'index'));	 				
				}	
			
					
      } 
          $this->set('codann',$id); 			
	}

	public function admin_exterior($id)
	{	  $this->layout='bootFotos';
		  
		  
		  if (isset($_FILES["archivos"])) {
         //de se asi, para procesar los archivos subidos al servidor solo debemos recorrerlo
		$fe=date("Y-m-j H:i:s");
         $tot = count($_FILES["archivos"]["name"]);
         //este for recorre el arreglo mandado
         for ($i = 0; $i < $tot; $i++){
         //con el indice $i, podemos obtener la propiedad que desemos de cada archivo
         //para trabajar con este
            $tmp_name = $_FILES["archivos"]["tmp_name"][$i];  
            $nombre_imagen = $_FILES["archivos"]["name"][$i];                       
			$tipoimagen=$_FILES["archivos"]["type"][$i];    
			$tam=$_FILES["archivos"]["size"][$i];           
			$anuncio_id=$this->data['Foto']['anuncio_id'];  
			$nombre=$this->SubeArchivo2($nombre_imagen,$tmp_name); 
			
			$cli=new User();
			$cli->query("INSERT INTO fotos VALUES('','Foto Exterior','$nombre','d','$nombre_imagen','$tipoimagen','$tam','$anuncio_id','3','$fe','$fe') ");					
																					        				
			}	
			$this->Session->setFlash(__('La foto Exterior ha sido Grabada', true));
			
			if(@$this->data['Foto']['terminar']!=1){ //preguntamos si el usuario a terminado de llenar formulario 
				   //$this->redirect(array('controller'=>'fotos','action'=>'foto_otros'));	
				   $this->redirect(array('controller'=>'anuncios','action'=>'index'));		 
			    }else
				{   $this->Foto->CompletarFoto(4,$anuncio_id);
					$this->redirect(array('controller' => 'anuncios', 'action' => 'index'));	 				
				}	
			
			
      }      				
		 $this->set('codann',$id); 	
	}
	
/**
 * admin_edit method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_edit($id = null) {
		/*
		if (!$id && empty($this->data)) {
			$this->Session->setFlash(__('Invalid Foto', true));
			$this->redirect(array('action'=>'index'));
		}
		if (!empty($this->data)) {
			
				/* para editar fotos */
			/*    $nn=$this->request->data['Foto']['nombre'];							
			if($nn['name']!=null)
			{ 
			  $this->request->data['Foto']['nombre']=$this->SubeArchivo($this->data['Foto']['nombre']);
				$this->request->data['Foto']['nombre_imagen']=$nn['name'];
				$this->request->data['Foto']['tipo_imagen']=$nn['type'];
				$this->request->data['Foto']['tamano_imagen']=$nn['size']; 
			}else
			{  $this->request->data['Foto']['nombre']=$this->request->data['Foto']['nombreo'];
			}						
			/* FIn de editar fotos */								
			/*if ($this->Foto->save($this->data)) {
				$this->Session->setFlash(__('The Foto has been saved', true));
				$this->redirect(array('controller'=>'anuncios','action'=>'fotos'));
			} else {
				$this->Session->setFlash(__('The Foto could not be saved. Please, try again.', true));
			}
		}
		if (empty($this->data)) {
			$this->data = $this->Foto->read(null, $id);
		}
		$anuncios = $this->Foto->Anuncio->find('list');
		$this->set(compact('anuncios'));
		$this->layout='admin';
		parent::ComboTipoFoto();
		$this->set('codf',$id);
	*/
	//ttttttttttt
	$this->layout='bootFotos';
		parent::ComboTipoFoto();
		$this->set('codf',$id);
	
	if (!$this->Foto->exists($id)) {
			throw new NotFoundException(__('Invalid foto'));
		}
		if ($this->request->is(array('post', 'put'))) {
				/* para editar fotos */
			    $nn=$this->request->data['Foto']['nombre'];							
			if($nn['name']!=null)
			{ 
			  $this->request->data['Foto']['nombre']=$this->SubeArchivo($this->data['Foto']['nombre']);
				$this->request->data['Foto']['nombre_imagen']=$nn['name'];
				$this->request->data['Foto']['tipo_imagen']=$nn['type'];
				$this->request->data['Foto']['tamano_imagen']=$nn['size']; 
				$this->request->data['Foto']['tipo']=$this->request->data['Foto']['tipo'];
				$this->request->data['Foto']['titulo']=$this->request->data['Foto']['titulo'];
				
				
			}else
			{  $this->request->data['Foto']['nombre']=$this->request->data['Foto']['nombreo'];
			}						
			/* FIn de editar fotos */	
			
			if ($this->Foto->save($this->request->data)) {
				$this->Session->setFlash(__('La foto fue grabada.'));
				return $this->redirect(array('controller'=>'anuncios','action'=>'index'));
			} else {
				$this->Session->setFlash(__('La foto no fue grabada por favor intente mas tarde.'));
			}
		} else {
			$options = array('conditions' => array('Foto.' . $this->Foto->primaryKey => $id));
			$this->request->data = $this->Foto->find('first', $options);
		}
		$anuncios = $this->Foto->Anuncio->find('list');
		$this->set(compact('anuncios'));
		
		
	}

/**
 * admin_delete method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_delete($id = null) {
		$this->Foto->id = $id;
		if (!$this->Foto->exists()) {
			throw new NotFoundException(__('Invalid foto'));
		}
		$this->request->allowMethod('post', 'delete');
		if ($this->Foto->delete()) {
			$this->Session->setFlash(__('La Foto fue eliminada.'));
		} else {
			$this->Session->setFlash(__('The foto could not be deleted. Please, try again.'));
		}
		return $this->redirect(array('controller'=>'anuncios','action' => 'index'));
	}
	
	function admin_anunciar_paso2()
	{   if (!empty($this->data)) {
				$nn=$this->data['Foto']['nombre'];
				
				$idAnuncio2=$this->data['Foto']['anuncio_id']; //id del anuncio  
				$this->request->data['Foto']['titulo']='Foto principal';
				$this->request->data['Foto']['nombre']=$this->SubeArchivo($this->data['Foto']['nombre']);
				$this->request->data['Foto']['nombre_imagen']=$nn['name'];
				$this->request->data['Foto']['tipo_imagen']=$nn['type'];
				$this->request->data['Foto']['tamano_imagen']=$nn['size'];
				$this->request->data['Foto']['anuncio_id']=$idAnuncio2;
				
				if(@$this->data['Foto']['terminar']!=1){ //preguntamos si el usuario a terminado de llenar formulario
				
					$this->Foto->create();			
					if ($this->Foto->save($this->data)) {
						//$this->Video->save($this->data);
						$this->Session->setFlash(__('La Foto Principal fue grabada', true));
						 $this->redirect(array('controller'=>'fotos','action'=>'foto_interior'));  
					} else {
						$this->Session->setFlash(__('La Foto no pudo ser grabada. (verifique el tamaño de la foto)', true));
					}
				  
			    }else
				{   $this->Foto->CompletarFoto(2,$idAnuncio2);
					$this->redirect(array('controller' => 'anuncios', 'action' => 'index'));	 				
				}	
		}
		$anuncios = $this->Foto->Anuncio->find('list');
		$this->set(compact('anuncios'));
		//parent::buscador();						
		$this->layout = 'bootanunciar';
	}
	
	
	
	
	
	function SubeArchivo($v) {
        $path = APP. WEBROOT_DIR;

        $anio = date("Y");
        $mes = date("m");
        $folder = $path.DS.'fotos'.DS.$anio.DS.$mes;
        $name = $v['name'];

        if (!file_exists($folder)) {
            mkdir($folder, 0777, true);
        }
         $prefijo = substr(md5(uniqid(rand())),0,5);   
        $nameFolder = '/fotos/'.$anio.'/'.$mes.'/'.$prefijo."_".$name;

        if( !move_uploaded_file($v['tmp_name'] , $folder.DS.$prefijo."_".$name) ) {
            return false;
        }else{
            return $nameFolder;
        }
    }
	
	function admin_foto_interior()
	{ 	$fe=date("Y-m-j H:i:s");
	
	
	  if (isset($_FILES["archivos"])) {
         //de se asi, para procesar los archivos subidos al servidor solo debemos recorrerlo

         $tot = count($_FILES["archivos"]["name"]);
         //este for recorre el arreglo mandado
         for ($i = 0; $i < $tot; $i++){
         //con el indice $i, podemos obtener la propiedad que desemos de cada archivo
         //para trabajar con este
            $tmp_name = $_FILES["archivos"]["tmp_name"][$i];  
            $nombre_imagen = $_FILES["archivos"]["name"][$i];                       
			$tipoimagen=$_FILES["archivos"]["type"][$i];    
			$tam=$_FILES["archivos"]["size"][$i];           
			$anuncio_id=$this->data['Foto']['anuncio_id'];  
			$nombre=$this->SubeArchivo2($nombre_imagen,$tmp_name); 
			
			$clientes=new User();
	 	 	$clientes->query("INSERT INTO fotos VALUES('','Foto Interior','$nombre','d','$nombre_imagen','$tipoimagen','$tam','$anuncio_id','2','$fe','$fe') ");
															        				
			}	
			$this->Session->setFlash(__('La foto Interior ha sido Grabada', true));
			
			if(@$this->data['Foto']['terminar']!=1){ //preguntamos si el usuario a terminado de llenar formulario 
				   $this->redirect(array('controller'=>'fotos','action'=>'foto_exterior')); 
			    }else
				{   $this->Foto->CompletarFoto(3,$anuncio_id);
					$this->redirect(array('controller' => 'anuncios', 'action' => 'index'));	 				
				}	
			
					
      }      				
		$this->layout = 'bootanunciar';	
	}
	
	function admin_foto_exterior()
	{	if (isset($_FILES["archivos"])) {
         //de se asi, para procesar los archivos subidos al servidor solo debemos recorrerlo
		$fe=date("Y-m-j H:i:s");
         $tot = count($_FILES["archivos"]["name"]);
         //este for recorre el arreglo mandado
         for ($i = 0; $i < $tot; $i++){
         //con el indice $i, podemos obtener la propiedad que desemos de cada archivo
         //para trabajar con este
            $tmp_name = $_FILES["archivos"]["tmp_name"][$i];  
            $nombre_imagen = $_FILES["archivos"]["name"][$i];                       
			$tipoimagen=$_FILES["archivos"]["type"][$i];    
			$tam=$_FILES["archivos"]["size"][$i];           
			$anuncio_id=$this->data['Foto']['anuncio_id'];  
			$nombre=$this->SubeArchivo2($nombre_imagen,$tmp_name); 
			
			$cli=new User();
			$cli->query("INSERT INTO fotos VALUES('','Foto Exterior','$nombre','d','$nombre_imagen','$tipoimagen','$tam','$anuncio_id','3','$fe','$fe') ");					
																					        				
			}	
			$this->Session->setFlash(__('La foto Exterior ha sido Grabada', true));
			
			if(@$this->data['Foto']['terminar']!=1){ //preguntamos si el usuario a terminado de llenar formulario 
				   //$this->redirect(array('controller'=>'fotos','action'=>'foto_otros'));	
				   $this->redirect(array('controller'=>'info_contactos','action'=>'anunciar_paso3'));		 
			    }else
				{   $this->Foto->CompletarFoto(4,$anuncio_id);
					$this->redirect(array('controller' => 'anuncios', 'action' => 'index'));	 				
				}	
			
			
      }      				
		$this->layout = 'bootanunciar';	
	
	}
	function admin_foto_otros()
	{ if (isset($_FILES["archivos"])) {
         //de se asi, para procesar los archivos subidos al servidor solo debemos recorrerlo
		
		$fe=date("Y-m-j H:i:s");
         $tot = count($_FILES["archivos"]["name"]);
         //este for recorre el arreglo mandado
         for ($i = 0; $i < $tot; $i++){
         //con el indice $i, podemos obtener la propiedad que desemos de cada archivo
         //para trabajar con este
            $tmp_name = $_FILES["archivos"]["tmp_name"][$i];  
            $nombre_imagen = $_FILES["archivos"]["name"][$i];                       
			$tipoimagen=$_FILES["archivos"]["type"][$i];    
			$tam=$_FILES["archivos"]["size"][$i];           
			$anuncio_id=$this->data['Foto']['anuncio_id'];  
			$nombre=$this->SubeArchivo2($nombre_imagen,$tmp_name); 
								
			$us=new User();
			$us->query("INSERT INTO fotos VALUES('','Foto Otros','$nombre','d','$nombre_imagen','$tipoimagen','$tam','$anuncio_id','4','$fe','$fe') ");					
																					        				
			}	
			$this->Session->setFlash(__('La foto Otros, ha sido Grabada', true));
					
			
			if(@$this->data['Foto']['terminar']!=1){ //preguntamos si el usuario a terminado de llenar formulario 
					$this->redirect(array('controller'=>'info_contactos','action'=>'anunciar_paso3'));		 
			    }else
				{   $this->Foto->CompletarFoto(5,$anuncio_id);
					$this->redirect(array('controller' => 'anuncios', 'action' => 'index'));	 				
				}	
      }      				
		$this->layout = 'bootanunciar';	
		
	}
	function SubeArchivo2($nom,$tem) {
		//Se manda como datos de entrada el nombre y temporal
        $path = APP. WEBROOT_DIR;
        $anio = date("Y");
        $mes = date("m");
        $folder = $path.DS.'fotos'.DS.$anio.DS.$mes;
        $name = $nom;

        if (!file_exists($folder)) {
            mkdir($folder, 0777, true);
        }
         $prefijo = substr(md5(uniqid(rand())),0,5);   
        $nameFolder = '/fotos/'.$anio.'/'.$mes.'/'.$prefijo."_".$name;

        if( !move_uploaded_file($tem , $folder.DS.$prefijo."_".$name) ) {
            return false;
        }else{
            return $nameFolder;
        }
    }
	function admin_detalle($id=null)
	{   $this->set('codan',$id);
		$this->layout='bootFotos';
	}
}
