<?php
App::uses('AppController', 'Controller');
/**
 * InfoContactos Controller
 *
 * @property InfoContacto $InfoContacto
 * @property PaginatorComponent $Paginator
 */
class InfoContactosController extends AppController {

/**
 * Components
 *
 * @var array
 */
	public $components = array('Paginator');
	public $uses=array('InfoContacto','Anuncio');
/**
 * index method
 *
 * @return void
 */
	public function index() {
		$this->InfoContacto->recursive = 0;
		$this->set('infoContactos', $this->Paginator->paginate());
	}

/**
 * view method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function view($id = null) {
		if (!$this->InfoContacto->exists($id)) {
			throw new NotFoundException(__('Invalid info contacto'));
		}
		$options = array('conditions' => array('InfoContacto.' . $this->InfoContacto->primaryKey => $id));
		$this->set('infoContacto', $this->InfoContacto->find('first', $options));
	}

/**
 * add method
 *
 * @return void
 */
	public function add() {
		if ($this->request->is('post')) {
			$this->InfoContacto->create();
			if ($this->InfoContacto->save($this->request->data)) {
				$this->Session->setFlash(__('The info contacto has been saved.'));
				return $this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The info contacto could not be saved. Please, try again.'));
			}
		}
		$anuncios = $this->InfoContacto->Anuncio->find('list');
		$this->set(compact('anuncios'));
	}

/**
 * edit method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function edit($id = null) {
		if (!$this->InfoContacto->exists($id)) {
			throw new NotFoundException(__('Invalid info contacto'));
		}
		if ($this->request->is(array('post', 'put'))) {
			if ($this->InfoContacto->save($this->request->data)) {
				$this->Session->setFlash(__('The info contacto has been saved.'));
				return $this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The info contacto could not be saved. Please, try again.'));
			}
		} else {
			$options = array('conditions' => array('InfoContacto.' . $this->InfoContacto->primaryKey => $id));
			$this->request->data = $this->InfoContacto->find('first', $options);
		}
		$anuncios = $this->InfoContacto->Anuncio->find('list');
		$this->set(compact('anuncios'));
	}

/**
 * delete method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function delete($id = null) {
		$this->InfoContacto->id = $id;
		if (!$this->InfoContacto->exists()) {
			throw new NotFoundException(__('Invalid info contacto'));
		}
		$this->request->allowMethod('post', 'delete');
		if ($this->InfoContacto->delete()) {
			$this->Session->setFlash(__('The info contacto has been deleted.'));
		} else {
			$this->Session->setFlash(__('The info contacto could not be deleted. Please, try again.'));
		}
		return $this->redirect(array('action' => 'index'));
	}

/**
 * admin_index method
 *
 * @return void
 */
	public function admin_index() {
		$this->paginate = array('limit' => 20, 'order' => array('InfoContacto.id' => 'desc')); //ordenar anuncio por un campo
		$this->InfoContacto->recursive = 0;
		$this->set('infoContactos', $this->Paginator->paginate());
		//$this->layout='admin';
		$this->layout='bootcliente';
	}

/**
 * admin_view method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_view($id = null) {
		if (!$this->InfoContacto->exists($id)) {
			throw new NotFoundException(__('Invalid info contacto'));
		}
		$options = array('conditions' => array('InfoContacto.' . $this->InfoContacto->primaryKey => $id));
		$this->set('infoContacto', $this->InfoContacto->find('first', $options));
		$this->layout='bootcliente';
	}

/**
 * admin_add method
 *
 * @return void
 */
	public function admin_add() {
		if ($this->request->is('post')) {
			$this->InfoContacto->create();
			if ($this->InfoContacto->save($this->request->data)) {
				$this->Session->setFlash(__('The info contacto has been saved.'));
				return $this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The info contacto could not be saved. Please, try again.'));
			}
		}
		$anuncios = $this->InfoContacto->Anuncio->find('list');
		$this->set(compact('anuncios'));
		$this->layout='admin';
	}

/**
 * admin_edit method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_edit($id = null) {
		if (!$this->InfoContacto->exists($id)) {
			throw new NotFoundException(__('Invalid info contacto'));
		}
		if ($this->request->is(array('post', 'put'))) {
			if ($this->InfoContacto->save($this->request->data)) {
				$this->Session->setFlash(__('The info contacto has been saved.'));
				return $this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The info contacto could not be saved. Please, try again.'));
			}
		} else {
			$options = array('conditions' => array('InfoContacto.' . $this->InfoContacto->primaryKey => $id));
			$this->request->data = $this->InfoContacto->find('first', $options);
		}
		$anuncios = $this->InfoContacto->Anuncio->find('list');
		$this->set(compact('anuncios'));
		$this->layout='bootcliente';
	}

/**
 * admin_delete method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_delete($id = null) {
		$this->InfoContacto->id = $id;
		if (!$this->InfoContacto->exists()) {
			throw new NotFoundException(__('Invalid info contacto'));
		}
		$this->request->allowMethod('post', 'delete');
		if ($this->InfoContacto->delete()) {
			$this->Session->setFlash(__('The info contacto has been deleted.'));
		} else {
			$this->Session->setFlash(__('The info contacto could not be deleted. Please, try again.'));
		}
		return $this->redirect(array('action' => 'index'));
	}
	
	function admin_anunciar_paso3()
	{
		 if (!empty($this->data)) {
				$idAnuncio=$this->data['InfoContacto']['anuncio_id'];
			$this->InfoContacto->create();						
			
				if(@$this->data['InfoContacto']['terminar']!=1){ //preguntamos si el usuario a terminado de llenar formulario
						if ($this->InfoContacto->save($this->data)) {
																	
							$this->Anuncio->id=$idAnuncio;
							$this->Anuncio->saveField('estado','1');
						
							$this->Session->setFlash(__('La Información del dueño del inmueble fue grabado', true));
							} else {
							$this->Session->setFlash(__('La Información del dueño del inmueble NO pudo ser grabado', true));
							}			   
								   
					$this->InfoContacto->CompletarCliente($this,0,$idAnuncio); 
					$this->redirect(array('controller'=>'anuncios','action'=>'finalizar'));		 
			    }else
				{   $this->InfoContacto->CompletarCliente($this,6,$idAnuncio);
					$this->redirect(array('controller' => 'anuncios', 'action' => 'index'));	 				
				}	
		}
		 
		$anuncios = $this->InfoContacto->Anuncio->find('list');
		$this->set(compact('anuncios'));
		//parent::buscador();
		$this->layout = 'bootanunciar';	
	}
	function admin_busqueda()
	{
	$this->set('infoContactos', $this->InfoContacto->busqueda($this, $this->data['InfoContacto']['busqueda']));	
	$this->layout='bootcliente';
	 }
}
