<?php
App::uses('AppController', 'Controller');
/**
 * Maximos Controller
 *
 * @property Maximo $Maximo
 * @property PaginatorComponent $Paginator
 */
class MaximosController extends AppController {

/**
 * Components
 *
 * @var array
 */
	public $components = array('Paginator');

/**
 * index method
 *
 * @return void
 */
	public function index() {
		$this->Maximo->recursive = 0;
		$this->set('maximos', $this->Paginator->paginate());
	}

/**
 * view method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function view($id = null) {
		if (!$this->Maximo->exists($id)) {
			throw new NotFoundException(__('Invalid maximo'));
		}
		$options = array('conditions' => array('Maximo.' . $this->Maximo->primaryKey => $id));
		$this->set('maximo', $this->Maximo->find('first', $options));
	}

/**
 * add method
 *
 * @return void
 */
	public function add() {
		if ($this->request->is('post')) {
			$this->Maximo->create();
			if ($this->Maximo->save($this->request->data)) {
				$this->Session->setFlash(__('The maximo has been saved.'));
				return $this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The maximo could not be saved. Please, try again.'));
			}
		}
		$tipos = $this->Maximo->Tipo->find('list');
		$this->set(compact('tipos'));
	}

/**
 * edit method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function edit($id = null) {
		if (!$this->Maximo->exists($id)) {
			throw new NotFoundException(__('Invalid maximo'));
		}
		if ($this->request->is(array('post', 'put'))) {
			if ($this->Maximo->save($this->request->data)) {
				$this->Session->setFlash(__('The maximo has been saved.'));
				return $this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The maximo could not be saved. Please, try again.'));
			}
		} else {
			$options = array('conditions' => array('Maximo.' . $this->Maximo->primaryKey => $id));
			$this->request->data = $this->Maximo->find('first', $options);
		}
		$tipos = $this->Maximo->Tipo->find('list');
		$this->set(compact('tipos'));
	}

/**
 * delete method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function delete($id = null) {
		$this->Maximo->id = $id;
		if (!$this->Maximo->exists()) {
			throw new NotFoundException(__('Invalid maximo'));
		}
		$this->request->allowMethod('post', 'delete');
		if ($this->Maximo->delete()) {
			$this->Session->setFlash(__('The maximo has been deleted.'));
		} else {
			$this->Session->setFlash(__('The maximo could not be deleted. Please, try again.'));
		}
		return $this->redirect(array('action' => 'index'));
	}

/**
 * admin_index method
 *
 * @return void
 */
	public function admin_index() {
		$this->Maximo->recursive = 0;
		$this->set('maximos', $this->Paginator->paginate());
	}

/**
 * admin_view method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_view($id = null) {
		if (!$this->Maximo->exists($id)) {
			throw new NotFoundException(__('Invalid maximo'));
		}
		$options = array('conditions' => array('Maximo.' . $this->Maximo->primaryKey => $id));
		$this->set('maximo', $this->Maximo->find('first', $options));
	}

/**
 * admin_add method
 *
 * @return void
 */
	public function admin_add() {
		if ($this->request->is('post')) {
			$this->Maximo->create();
			if ($this->Maximo->save($this->request->data)) {
				$this->Session->setFlash(__('The maximo has been saved.'));
				return $this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The maximo could not be saved. Please, try again.'));
			}
		}
		$tipos = $this->Maximo->Tipo->find('list');
		$this->set(compact('tipos'));
	}

/**
 * admin_edit method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_edit($id = null) {
		if (!$this->Maximo->exists($id)) {
			throw new NotFoundException(__('Invalid maximo'));
		}
		if ($this->request->is(array('post', 'put'))) {
			if ($this->Maximo->save($this->request->data)) {
				$this->Session->setFlash(__('The maximo has been saved.'));
				return $this->redirect(array('action' => 'index'));
			} else {
				$this->Session->setFlash(__('The maximo could not be saved. Please, try again.'));
			}
		} else {
			$options = array('conditions' => array('Maximo.' . $this->Maximo->primaryKey => $id));
			$this->request->data = $this->Maximo->find('first', $options);
		}
		$tipos = $this->Maximo->Tipo->find('list');
		$this->set(compact('tipos'));
	}

/**
 * admin_delete method
 *
 * @throws NotFoundException
 * @param string $id
 * @return void
 */
	public function admin_delete($id = null) {
		$this->Maximo->id = $id;
		if (!$this->Maximo->exists()) {
			throw new NotFoundException(__('Invalid maximo'));
		}
		$this->request->allowMethod('post', 'delete');
		if ($this->Maximo->delete()) {
			$this->Session->setFlash(__('The maximo has been deleted.'));
		} else {
			$this->Session->setFlash(__('The maximo could not be deleted. Please, try again.'));
		}
		return $this->redirect(array('action' => 'index'));
	}
}
