<?php
App::uses('AppModel', 'Model');
App::uses('SimplePasswordHasher','Controller/Component/Auth');

/**
 * User Model
 *
 * @property Anuncio $Anuncio
 */
class User extends AppModel {

/**
 * Validation rules
 *
 * @var array
 */
	public $validate = array(
		'nombre' => array(
			'notBlank' => array(
				'rule' => array('notBlank'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'apellido' => array(
			'notBlank' => array(
				'rule' => array('notBlank'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'celular' => array(
			'notBlank' => array(
				'rule' => array('notBlank'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'rol' => array(
			'notBlank' => array(
				'rule' => array('notBlank'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'username' => array(
            'notempty' => array(
                'rule' => array('notBlank'), 
                    'required' => true, 
                       'allowEmpty' => false,
                          'message' => 'El nombre de usuario no puede estar vacio.'),
                            'unique' => array( 'rule' => array('checkUnique', 'username'), 'message' => 'Nombre de usuario tomado, utilice otro.')),
		'password' => array(
			 'notempty' => array(
					'rule' => array('notBlank'),
						'required' => true,
							'allowEmpty' => false,
							    'message' => 'La clave no debe de ser en blanco.'),
									'passwordSimilar' => array(
										'rule' => 'checkPasswords',
											'message' => 'Debe de coincidir la clave.'),
											'mustBeLonger'=>array(
						'rule' => array('minLength', 6),
						'message'=> 'La contraseña debe tener más de 5 caracteres',
						'on' => 'create',
						'last'=>true)
											)
	);

	//The Associations below have been created with all possible keys, those that are not needed can be removed

/**
 * hasMany associations
 *
 * @var array
 */
	public $hasMany = array(
		'Anuncio' => array(
			'className' => 'Anuncio',
			'foreignKey' => 'user_id',
			'dependent' => false,
			'conditions' => '',
			'fields' => '',
			'order' => '',
			'limit' => '',
			'offset' => '',
			'exclusive' => '',
			'finderQuery' => '',
			'counterQuery' => ''
		)
	);
	function veAdmin($controller,$u=null,$p=null)
	{  /*Metodo de administrador */
	   /*Este metodo verifica si un usuario es de tipo admin para ingresar al sistema*/ 
	   $u=stripslashes(strip_tags(trim($u)));
	   $p=AuthComponent::password(stripslashes(strip_tags(trim($p))));		
	    
		$v=$controller->User->query("SELECT * FROM users WHERE (username='$u' and password='$p') and rol='admin'");
	
		$fila=count($v);
		if($fila>0){	      	 
		 $li[]=$fila;	
		 $li[]=$v['0']['users']['rol']; //debe mandar rol= admin
		}
		else {
			$li[]=$fila;	
		 	$li[]=0; //debe mandar rol= admin
		}	
	  return $li;			
	}
	
	public function beforeSave($options = array()) {	
	// hash our password
        if (isset($this->data[$this->alias]['password'])) {
            $this->data[$this->alias]['password'] = AuthComponent::password($this->data[$this->alias]['password']);
        }
         
        // if we get a new password, hash it
        if (isset($this->data[$this->alias]['password_update']) && !empty($this->data[$this->alias]['password_update'])) {
            $this->data[$this->alias]['password'] = AuthComponent::password($this->data[$this->alias]['password_update']);
        }
     
        // fallback to our parent
        return parent::beforeSave($options);
	}
	
	function checkUnique($data, $fieldName) { 
  		$valid = false; 
     	if(isset($fieldName) && $this->hasField($fieldName)) { 
         	$valid = $this->isUnique(array($fieldName => $data)); 
        } 
        return $valid; 
  	} 
	
	function checkPasswords($data) {			
		if(AuthComponent::password($data['password']) == $this->data['User']['password2hashed'])
			return true; 
		return false; 
	} 
}
