<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Capa;

/**
 * CapaSearch represents the model behind the search form about `app\models\Capa`.
 */
class CapaSearch extends Capa
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['IdCapa', 'IdcTipoCapa', 'IdCreadoPor', 'IdModificadoPor'], 'integer'],
            [['IdcTipoMapa', 'FechaModificacion', 'FechaCreacion'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Capa::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'IdCapa' => $this->IdCapa,
            'IdcTipoCapa' => $this->IdcTipoCapa,
            'IdCreadoPor' => $this->IdCreadoPor,
            'FechaModificacion' => $this->FechaModificacion,
            'FechaCreacion' => $this->FechaCreacion,
            'IdModificadoPor' => $this->IdModificadoPor,
        ]);

        $query->andFilterWhere(['like', 'IdcTipoMapa', $this->IdcTipoMapa]);

        return $dataProvider;
    }
}
