<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "capadetalle".
 *
 * @property integer $IdCapaDetalle
 * @property integer $IdCapa
 * @property string $Codigo
 * @property integer $Anio
 * @property string $valor
 *
 * @property Capa $idCapa
 */
class Capadetalle extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'capadetalle';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['IdCapa'], 'required'],
            [['IdCapa', 'Anio'], 'integer'],
            [['valor'], 'number'],
            [['Codigo'], 'string', 'max' => 45],
            [['IdCapa'], 'exist', 'skipOnError' => true, 'targetClass' => Capa::className(), 'targetAttribute' => ['IdCapa' => 'IdCapa']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'IdCapaDetalle' => 'Id Capa Detalle',
            'IdCapa' => 'Id Capa',
            'Codigo' => 'Codigo',
            'Anio' => 'Anio',
            'valor' => 'Valor',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getIdCapa()
    {
        return $this->hasOne(Capa::className(), ['IdCapa' => 'IdCapa']);
    }
}
