<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Clasificadorcomun;
use yii\helpers\ArrayHelper;

/**
 * ClasificadorcomunSearch represents the model behind the search form about `app\models\Clasificadorcomun`.
 */
class ClasificadorcomunSearch extends Clasificadorcomun
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['IdClasificadorComun', 'IdTipoClasificadorComun'], 'integer'],
            [['Nombre', 'Abreviacion', 'Descripcion', 'Orden'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Clasificadorcomun::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'IdClasificadorComun' => $this->IdClasificadorComun,
            'IdTipoClasificadorComun' => $this->IdTipoClasificadorComun,
        ]);

        $query->andFilterWhere(['like', 'Nombre', $this->Nombre])
            ->andFilterWhere(['like', 'Abreviacion', $this->Abreviacion])
            ->andFilterWhere(['like', 'Descripcion', $this->Descripcion])
            ->andFilterWhere(['like', 'Orden', $this->Orden]);

        return $dataProvider;
    }

    /**
     * $idTipoClasificador : Id clasificador Comun
     * @param $idTipoClasificador integer
     * @return Array
     */
    public static  function combo($idTipoClasificador){
        $combo = Clasificadorcomun::find()->where(["IdTipoClasificadorComun"=>$idTipoClasificador ])->all();
        $combo = ArrayHelper::map($combo, 'IdClasificadorComun','Nombre' );
        return $combo;
    }

    /**
     * Retorna items del TipoClasificador
     * @param integer $idTipoClasificador
     * @return Clasificadorcomun[]|\yii\db\ActiveRecord[]
     */
    public static  function allItems($idTipoClasificador){
        $combo = Clasificadorcomun::find()->where(["IdTipoClasificadorComun"=>$idTipoClasificador ])->all();
        //$combo = ArrayHelper::map($combo, 'IdClasificadorComun','Nombre' );
        return $combo;
    }
}
