<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Empresa;

/**
 * EmpresaSearch represents the model behind the search form about `app\models\Empresa`.
 */
class EmpresaSearch extends Empresa
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['IdEmpresa', 'IdRepresentanteLegal'], 'integer'],
            [['ActividadEconomica', 'RazonSocial', 'Direccion', 'Telefonos', 'Emails', 'PaginaWeb', 'Nota'], 'safe'],
            [['Activo'], 'boolean'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Empresa::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andWhere(["Activo"=>1]);
        // grid filtering conditions
        $query->andFilterWhere([
            'IdEmpresa' => $this->IdEmpresa,
            'IdRepresentanteLegal' => $this->IdRepresentanteLegal,
            'Activo' => $this->Activo,
        ]);

        $query->andFilterWhere(['like', 'ActividadEconomica', $this->ActividadEconomica])
            ->andFilterWhere(['like', 'RazonSocial', $this->RazonSocial])
            ->andFilterWhere(['like', 'Direccion', $this->Direccion])
            ->andFilterWhere(['like', 'Telefonos', $this->Telefonos])
            ->andFilterWhere(['like', 'Emails', $this->Emails])
            ->andFilterWhere(['like', 'PaginaWeb', $this->PaginaWeb])
            ->andFilterWhere(['like', 'Nota', $this->Nota]);

        return $dataProvider;
    }
}
