<?php
/**
 * Created by PhpStorm.
 * User: hquispe
 * Date: 7/28/2016
 * Time: 10:43 AM
 */

namespace app\models;
use yii;
use app\commands\Clasificadores\TipoClasificador;
use app\commands\MapasCapas;
use yii\base\Model;
use yii\web\UploadedFile;

/**
 * Class KmzUpload
 * @package app\models
 * @property UploadedFile $KmzFile
 * @propert integer $TipoMapa
 * @propert string $dir
 */
class KmzUpload extends Model
{

    /**
     * @var UploadedFile[]
     */
    public $KmzFile;
    public $TipoMapa;
    public $dir = "/kmz"; //directorio donde se almacenara el archivo dentro de web/

    public function rules() {
        return [
            [['KmzFile','TipoMapa'], 'required'],
            [['KmzFile'], 'file','extensions'=>'kmz' ],
            [['TipoMapa'], 'integer' ]
        ];
    }


    public function validation()
    {

        if (!$this->validate(['TipoMapa'])) return false;
        if ($this->KmzFile->extension != "kmz") return false;

        return true;


    }
}