<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Persona;

/**
 * PersonaSearch represents the model behind the search form about `app\models\Persona`.
 */
class PersonaSearch extends Persona
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['IdPersona', 'IdCreadoPor', 'IdModificadoPor', 'IdcEstadoCivil'], 'integer'],
            [['Nombres', 'Apellidos', 'CiNit', 'Email', 'Direccion', 'FechaNacimiento'], 'safe'],
            [['Activo'], 'boolean'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Persona::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andWhere( ['Activo'=>1] ); // que no sea administrador
        $query->andWhere( ['!=','IdPersona',1] ); // que no sea administrador
        // grid filtering conditions
        $query->andFilterWhere([
            'IdPersona' => $this->IdPersona,
            'IdCreadoPor' => $this->IdCreadoPor,
            'IdModificadoPor' => $this->IdModificadoPor,
            'IdcEstadoCivil' => $this->IdcEstadoCivil,
            'FechaNacimiento' => $this->FechaNacimiento,
            'Activo' => $this->Activo,
        ]);

        $query->andFilterWhere(['like', 'Nombres', $this->Nombres])
            ->andFilterWhere(['like', 'Apellidos', $this->Apellidos])
            ->andFilterWhere(['like', 'CiNit', $this->CiNit])
            ->andFilterWhere(['like', 'Email', $this->Email])
            ->andFilterWhere(['like', 'Direccion', $this->Direccion]);

        return $dataProvider;
    }
}
