<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Proyecto;

/**
 * ProyectoSearch represents the model behind the search form about `app\models\Proyecto`.
 */
class ProyectoSearch extends Proyecto
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            /*
            [['IdProyecto', 'IdcTipoProyecto', 'IdEmpresa', 'IdCreadoPor', 'IdModificadoPor', 'IdcEstadoProyecto'], 'integer'],
            [['NombreProyecto', 'Notas', 'FechaCreacion', 'FechaModificacion'], 'safe'],
            [['SuperficieTerreno', 'SuperficieTotalConstruida', 'CostoTotalProyecto', 'Latitud', 'Longitud'], 'number'],
            */
                [['IdProyecto', 'IdCreadoPor', 'IdModificadoPor', 'IdcEstadoProyecto'], 'integer'],
                [['NombreProyecto', 'FechaCreacion', 'FechaModificacion'], 'safe'],
                [[ 'Latitud', 'Longitud'], 'number'],

        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Proyecto::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'IdProyecto' => $this->IdProyecto,
            //'IdcTipoProyecto' => $this->IdcTipoProyecto,
            //'IdEmpresa' => $this->IdEmpresa,
            //'SuperficieTerreno' => $this->SuperficieTerreno,
            //'SuperficieTotalConstruida' => $this->SuperficieTotalConstruida,
            //'CostoTotalProyecto' => $this->CostoTotalProyecto,
            'Latitud' => $this->Latitud,
            'Longitud' => $this->Longitud,
            'IdCreadoPor' => $this->IdCreadoPor,
            'FechaCreacion' => $this->FechaCreacion,
            'IdModificadoPor' => $this->IdModificadoPor,
            'FechaModificacion' => $this->FechaModificacion,
            'IdcEstadoProyecto' => $this->IdcEstadoProyecto,
        ]);

        $query->andFilterWhere(['like', 'NombreProyecto', $this->NombreProyecto]);
            //->andFilterWhere(['like', 'Notas', $this->Notas])

        return $dataProvider;
    }
}
