<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\User;

/**
 * UserSearch represents the model behind the search form about `app\models\User`.
 */
class UserSearch extends User
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'IdPersona', 'IdCreadoPor', 'IdModificadoPor'], 'integer'],
            [['username', 'auth_key', 'password_hash', 'password_reset_token', 'access_token', 'FechaCreacion', 'Rol'], 'safe'],
            [['Activo'], 'boolean'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = User::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }


        $query->andWhere(['Activo'=>1]);  // y solo los activos
        $query->andWhere(['!=','id',1]); //excepto el primer registro
        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'IdPersona' => $this->IdPersona,
            'IdCreadoPor' => $this->IdCreadoPor,
            'FechaCreacion' => $this->FechaCreacion,
            'IdModificadoPor' => $this->IdModificadoPor,
            //'Activo' => $this->Activo,
        ]);

        $query->andFilterWhere(['like', 'username', $this->username])
            ->andFilterWhere(['like', 'auth_key', $this->auth_key])
            ->andFilterWhere(['like', 'password_hash', $this->password_hash])
            ->andFilterWhere(['like', 'password_reset_token', $this->password_reset_token])
            ->andFilterWhere(['like', 'access_token', $this->access_token])
            ->andFilterWhere(['like', 'Rol', $this->Rol]);

        return $dataProvider;
    }
}
