<?php

use kartik\select2\Select2;
use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\EmpresaSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Empresas';
$this->params['breadcrumbs'][] = $this->title;

$param = $param = Yii::$app->request->queryParams;
?>
<div class="empresa-index">

    <h1><?= Html::encode($this->title) ?></h1>
    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>

    <p>
        <?= Html::a('Crear Empresa', ['create'], ['class' => 'btn btn-success']) ?>
    </p>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'RazonSocial',
            //'IdEmpresa',
            [
                'attribute'=>'representante',
                'label'=>'Representate Legal',
                'value'=>function($model){ return $model->idRepresentanteLegal->Nombres.' '.$model->idRepresentanteLegal->Apellidos; },
                    'filter'=> Select2::widget([
                            'name' => 'EmpresaSearch[IdRepresentanteLegal]',
                            'data' => $comboPersonas,
                            'value'=> isset($param['EmpresaSearch']['IdRepresentanteLegal'])?$param['EmpresaSearch']['IdRepresentanteLegal']:0,
                        'size' => Select2::SMALL,
                        //'hideSearch' => true,
                            'options' => [
                                    'placeholder' => 'Seleccione'
                            ],
                            'pluginOptions' => [
                                    'allowClear' => true
                            ],
                    ])
            ],
            'ActividadEconomica',

            'Direccion',
            // 'Telefonos',
            // 'Emails:email',
            // 'PaginaWeb',
            // 'Nota:ntext',
            // 'Activo:boolean',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>
</div>
