<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Empresa */

$this->title = $model->RazonSocial;
$this->params['breadcrumbs'][] = ['label' => 'Empresas', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="empresa-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Actualizar', ['update', 'id' => $model->IdEmpresa], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Eliminar', ['delete', 'id' => $model->IdEmpresa], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => '¿Está seguro de eliminar este elemento?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'IdEmpresa',
            'RazonSocial',
            [
                'label'=>"Representante Legal",
                'value'=>$model->idRepresentanteLegal->Nombres ." ".$model->idRepresentanteLegal->Apellidos
            ],
            'ActividadEconomica',

            'Direccion',
            'Telefonos',
            'Emails:email',
            [
                'label'=>'Pagina Web',
                'value'=>   !empty($model->PaginaWeb)? Html::a($model->PaginaWeb, $model->PaginaWeb):"-",
                 'format'=>'raw'

            ],
            'Nota:ntext',
             [
                 'label'=>"Activo",
                 'value'=>$model->Activo?"Si":"No"
             ]
        ],
    ]) ?>

</div>
