<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use kartik\date\DatePicker;

/* @var $this yii\web\View */
/* @var $model app\models\Persona */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="persona-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'Nombres')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'Apellidos')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'IdcEstadoCivil')->dropDownList( $comboEstadoCivil,[
        'options'=>[$model->IdcEstadoCivil=>['Selected'=>'selected']  ],
        'prompt'=>'--Seleccione Estado Civil'
    ] )->label("Estado Civil") ?>

    <?= $form->field($model, 'CiNit')->textInput(['maxlength' => true])->label('CI') ?>

    <?= $form->field($model, 'Email')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'Direccion')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'Telefonos')->textInput(['maxlength' => true]) ?>


    <?= $form->field($model, 'FechaNacimiento')->widget( DatePicker::classname(),
        [
            'language' => 'es',
            //'value' => date('Y-m-d'),
            'options' => ['placeholder' => 'Introduzca Fecha ...'],
            'pluginOptions' => [
                'format' => 'yyyy-mm-dd',
                'todayHighlight' => true
            ]
        ]) ?>



    <?php if( !$model->isNewRecord  ){ ?>
        <?= $form->field($model, 'Activo')->checkbox() ?>
    <?php }

    ?>

    <div class="form-group">
        <?= Html::submitButton($model->isNewRecord ? 'Create' : 'Update', ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>
