<?php

use kartik\select2\Select2;
use yii\helpers\Html;
use yii\grid\GridView;
use yii\widgets\Pjax;
/* @var $this yii\web\View */
/* @var $searchModel app\models\UserSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Usuarios';
$this->params['breadcrumbs'][] = $this->title;

$param = $param = Yii::$app->request->queryParams;
?>
<div class="user-index">

    <h1><?= Html::encode($this->title) ?></h1>
    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>

    <p>
        <?= Html::a('Crear Usuario', ['create'], ['class' => 'btn btn-success']) ?>
    </p>
    <?php Pjax::begin(); ?>    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            //'id',
            //'IdPersona',
            [
                'label'=>'Persona',
                'value'=>function($model){
                    return $model->idPersona->Nombres." ".$model->idPersona->Apellidos;
                }
            ],
            'username',
            //'auth_key',
            //'password_hash',
            // 'password_reset_token',
            // 'access_token',
            // 'IdCreadoPor',
            // 'FechaCreacion',
            // 'IdModificadoPor',
             //'Rol',
             [
                 'label'=>'Rol',
                 'value'=>function($mod){ return   \app\commands\Roles::$items[$mod->Rol] ; },
                     'filter'=> Select2::widget([
                             'name' => 'UserSearch[Rol]',
                             'data' => \app\commands\Roles::$items,
                             'value'=> isset($param['UserSearch']['Rol'])?$param['UserSearch']['Rol']:0,
                             'hideSearch' => true,
                             'options' => [
                                     'placeholder' => 'Seleccione'
                             ],
                             'pluginOptions' => [
                                     'allowClear' => true
                             ],
                     ])
             ],
             'Activo:boolean',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>
    <?php Pjax::end(); ?></div>
